; 
    include \masm32\include\masm32rt.inc
; 

    .xmm

comment * -----------------------------------------------------
                        Build this  template with
                       "CONSOLE ASSEMBLE AND LINK"
        ----------------------------------------------------- *

    sseCopyO PROTO :DWORD,:DWORD,:DWORD
    MemCopyD PROTO :DWORD,:DWORD,:DWORD
    ntwCopyD PROTO :DWORD,:DWORD,:DWORD
    ntwCopyQ PROTO :DWORD,:DWORD,:DWORD
    regcopy  PROTO :DWORD,:DWORD,:DWORD

    bsize equ <1024>
    lcnt  equ <3000000>

    .data?
      align 16
      txt db 65536 dup (?)
      align 16
      buf db 65536 dup (?)

    .code

start:

; 

    call main
    inkey
    exit

; 

main proc

    LOCAL pmem1 :DWORD
    LOCAL pmem2 :DWORD

    push ebx
    push esi
    push edi

  REPEAT 8
  ; ------------------------------------------

    invoke GetTickCount
    push eax
    mov ebx, lcnt
  @@:
    invoke sseCopyO,ADDR txt,ADDR buf,bsize
    sub ebx, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," 1 MS duration sseCopyO",13,10

  ; ------------------------------------------

    invoke GetTickCount
    push eax
    mov ebx, lcnt
  @@:
    invoke regcopy,ADDR txt,ADDR buf,bsize
    sub ebx, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," 1 MS duration regcopy",13,10

  ; ------------------------------------------

    invoke GetTickCount
    push eax
    mov ebx, lcnt
  @@:
    invoke ntwCopyD,ADDR txt,ADDR buf,bsize
    sub ebx, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," 1 MS duration ntwCopyD",13,10

  ; ------------------------------------------

    invoke GetTickCount
    push eax
    mov ebx, lcnt
  @@:
    invoke ntwCopyQ,ADDR txt,ADDR buf,bsize
    sub ebx, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," 1 MS duration ntwCopyQ",13,10

  ; ------------------------------------------

    invoke GetTickCount
    push eax
    mov ebx, lcnt
  @@:
    invoke MemCopyD,ADDR txt,ADDR buf,bsize
    sub ebx, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," 1 MS duration MemCopyD",13,10

  ; ------------------------------------------
  ENDM

    mov pmem1, alloc$(1024*1024*8)
    mov pmem2, alloc$(1024*1024*8)

    mov esi, pmem1
    mov edi, pmem2

    memalign esi, 16
    memalign edi, 16

    print hex$(esi)," esi",13,10
    print hex$(edi)," edi",13,10


  REPEAT 8
  ; ------------------------------------------

    invoke GetTickCount
    push eax
    mov ebx, lcnt
  @@:
    invoke sseCopyO,esi,edi,bsize
    sub ebx, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," 2 MS duration sseCopyO",13,10

  ; ------------------------------------------

    invoke GetTickCount
    push eax
    mov ebx, lcnt
  @@:
    invoke regcopy,esi,edi,bsize
    sub ebx, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," 2 MS duration regcopy",13,10

  ; ------------------------------------------

    invoke GetTickCount
    push eax
    mov ebx, lcnt
  @@:
    invoke ntwCopyD,esi,edi,bsize
    sub ebx, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," 2 MS duration ntwCopyD",13,10

  ; ------------------------------------------

    invoke GetTickCount
    push eax
    mov ebx, lcnt
  @@:
    invoke ntwCopyQ,esi,edi,bsize
    sub ebx, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," 2 MS duration ntwCopyQ",13,10

  ; ------------------------------------------

    invoke GetTickCount
    push eax
    mov ebx, lcnt
  @@:
    invoke MemCopyD,esi,edi,bsize
    sub ebx, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," 2 MS duration MemCopyD",13,10

  ; ------------------------------------------
  ENDM


    free$ pmem2
    free$ pmem1

    pop edi
    pop esi
    pop ebx

    ret

main endp

; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 4

MemCopyD proc src:DWORD,dst:DWORD,ln:DWORD

    push esi
    push edi

    cld
    mov esi, [esp+4+8]
    mov edi, [esp+8+8]
    mov ecx, [esp+12+8]

    shr ecx, 2
    rep movsd

 ;     mov ecx, [esp+12+8]
 ;     and ecx, 3
 ;     rep movsb

    pop edi
    pop esi

    ret 12

MemCopyD endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 16

sseCopyO proc src:DWORD,dst:DWORD,ln:DWORD

    push ebx
    push esi
    push edi

    mov esi, [esp+4+12]
    mov edi, [esp+8+12]
    mov ebx, [esp+12+12]
    shr ebx, 7

  align 16
  @@:
    movdqa xmm0, [esi]
    movdqa xmm1, [esi+16]
    movdqa xmm2, [esi+32]
    movdqa xmm3, [esi+48]
    movdqa xmm4, [esi+64]
    movdqa xmm5, [esi+80]
    movdqa xmm6, [esi+96]
    movdqa xmm7, [esi+112]

    movntdq [edi], xmm0
    movntdq [edi+16], xmm1
    movntdq [edi+32], xmm2
    movntdq [edi+48], xmm3
    movntdq [edi+64], xmm4
    movntdq [edi+80], xmm5
    movntdq [edi+96], xmm6
    movntdq [edi+112], xmm7

    add esi, 128
    add edi, 128

    sub ebx, 1
    jnz @B

    pop edi
    pop esi
    pop ebx

    ret 12

sseCopyO endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 16

ntwCopyD proc src:DWORD,dst:DWORD,ln:DWORD

    push ebx
    push esi
    push edi
    push ebp

    mov esi, [esp+4+16]
    mov edi, [esp+8+16]
    mov ebx, [esp+12+16]

    shr ebx, 4

  align 16
  @@:
    mov eax, [esi]
    mov ecx, [esi+4]
    mov edx, [esi+8]
    mov ebp, [esi+12]

    movnti [edi], eax
    movnti [edi+4], ecx
    movnti [edi+8], edx
    movnti [edi+12], ebp

    sub ebx, 1
    jnz @B

    pop ebp
    pop edi
    pop esi
    pop ebx

    ret 12

ntwCopyD endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 16

ntwCopyQ proc src:DWORD,dst:DWORD,ln:DWORD

    push ebx
    push esi
    push edi

    mov esi, [esp+4+12]
    mov edi, [esp+8+12]
    mov ebx, [esp+12+12]

    shr ebx, 6

  align 16
  @@:
    movq mm0, [esi]
    movq mm1, [esi+8]
    movq mm2, [esi+16]
    movq mm3, [esi+24]
    movq mm4, [esi+32]
    movq mm5, [esi+40]
    movq mm6, [esi+48]
    movq mm7, [esi+56]

    movntq [edi], mm0
    movntq [edi+8], mm1
    movntq [edi+16], mm2
    movntq [edi+24], mm3
    movntq [edi+32], mm4
    movntq [edi+40], mm5
    movntq [edi+48], mm6
    movntq [edi+56], mm7
    sub ebx, 1
    jnz @B

    pop edi
    pop esi
    pop ebx

    ret 12

ntwCopyQ endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 16

regcopy proc src:DWORD,dst:DWORD,ln:DWORD

    push ebx
    push esi
    push edi
    push ebp

    mov esi, [esp+4+16]     ; src
    mov edi, [esp+8+16]     ; dst
    mov ecx, [esp+12+16]    ; ln

    shr ecx, 4              ; div by 8
    jz tail

  @@:
    mov eax, [esi]
    mov ebx, [esi+4]
    mov edx, [esi+8]
    mov ebp, [esi+12]
    mov [edi], eax
    mov [edi+4], ebx
    mov [edi+8], edx
    mov [edi+12], ebp
    add esi, 16
    add edi, 16
    sub ecx, 1
    jns @B

  tail:
 ;     mov ecx, [esp+12+16]    ; ln
 ;     and ecx, 4
 ;     jz quit
 ;
 ;   @@:
 ;     movzx eax, BYTE PTR [esi]
 ;     mov [edi], al
 ;     add esi, 1
 ;     add edi, 1
 ;     sub ecx, 1
 ;     jnz @B

  quit:
    pop ebp
    pop edi
    pop esi
    pop ebx

    ret 12

regcopy endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

end start

